/*
  BEHAVIORS : SOURCE FILE
  
  Behaviors:
    None play_on behavior
    Not seen ball behavior
    Player neck behavior
    Goaler play behavior
    Player play behavior

  Ehsan Foroughi 

  ParsAI Team
  Sharif University of Tech.

 */

#define _behaviors_behaviors_extern_
#include "behaviors.h"

void non_play_on_behavior(void)
{
  int i;
  
  if (LOG_BEHAVIOR) logmsg("Behavior : None play_on behavior acting.");

  if (player.playmode==PM_before_kick_off) i = (player.side==S_LEFT)^(world.time.clock>=(1))?0:1;
  else i = (player.playmode==PM_goal_l)^(player.side==S_LEFT)?0:1;

  if (!(equal_dist(arrange.begin_position[player.unum][i][0],world.body.loc.x)&&
        equal_dist(arrange.begin_position[player.unum][i][1],world.body.loc.y)))
    move(arrange.begin_position[player.unum][i][0],arrange.begin_position[player.unum][i][1]);
  else if (fabs(reldir_2me(0,0))>DIR_ERROR) {
    turn(reldir_2me(0,0));
    neck2zero();
  }
}

bool not_seen_ball_behavior(void)
{
  static Time last_unseen_time;
  
  if (LOG_BEHAVIOR) logmsg("Behavior : Not seen ball behavior acting.");

  if (timeval(world.time)-timeval(last_unseen_time)<2) return true;
  turn(view_angle()*2.0-3.0);
  neck2zero();
  world.ball.correctness=GHOST_CORRECTNESS;//+CORRECTNESS_DECAY;
  last_unseen_time = world.time;

  return true;
}

void player_neck_behavior(void)
{
//  return;
  if (world.ball.correctness>40) neck2ball();
  else neck2zero();
}

void player_view_behavior(void)
{
  if ((dist_2me(world.ball)<params.server.visdist) && (world.ball.correctness>50)) 
//    change_view(VW_Narrow,VQ_high);
    change_view(VW_Normal,VQ_high);
  else if (dist_2me(world.ball)>30 && world.ball.correctness>40)
    change_view(VW_Wide,VQ_high);
  else 
    change_view(VW_Normal,VQ_high);     
}


void goaler_play_behavior(void)
{
  double gx, gy;  // Beware of static
  static int state = 0;
  static int catch_st = 0;
  static int i = 0;
 
  if (LOG_BEHAVIOR) logmsg("Behavior : Goaler normal play_on behavior acting.");

  sprintf(debugbuf,"state = %d",state);
  logmsg(debugbuf);

//  if (!can_kickball()) world.body.ball_inhand = false;
  if (state==0) catch_st++;
  if (catch_st>9) world.body.ball_inhand = false;
  if (dist_2me(world.ball)>2) state=0;

  if (state > 2) state--;
  else if (state == 2) {
    i = pass.goaler_pass(gx, gy);
    move(gx,gy);
    state--;
  } else if (state == 1) {
    if (free_dist_circle()>4) {
      if (i!=0) kick(100,reldir_2me(world.tmate[i]));
      else kick(100,-world.body.loc.body_dir);
    };
    state = 0;
  } else if (can_catch()&&(!world.body.ball_inhand)) {
    gcatch(reldir_2me(world.ball));
    catch_st = 0;
  } else if ((world.body.ball_inhand)&&(can_kickball())&&(catch_st==1)) {
    turn(-world.body.loc.body_dir);
    catch_st++;
    state = 50;
  } else if (ball_in_region()) {
    if (can_kickball()) {
      if (pass.possible()) pass.perform();
      else kick(100,reldir_2me(0,genrand(40)-20));
    } else get_2ball.perform();
/*    } else {
      // Pooya
      if (speed(world.ball)>0.5) {
        int ii;
	bool fl;
	fl=false;
        for (ii=0;ii<10;ii++)
          if (estimate_ball_x(ii)<-(FIELD_LENGTH/2-2) && fabs(estimate_ball_y(ii)<(GOAL_WIDTH/2+2)))
	  {
	    fl=true;
	    break;
	  }    
	if (fl) 
	  get_2ball.perform();
	else  
	  goto_playing_post.perform();
      }
      else	
        get_2ball.perform();
    }*/
      
  } else {
    goto_playing_post.perform();
  };

  player_neck_behavior();
}

void player_play_behavior(void)
{
  if (LOG_BEHAVIOR) logmsg("Behavior : Player normal play_on behavior acting.");
  // by pooya
//if ((player.unum==get_2ball.can_get2ball_fastest())/*||(player.unum==nearmost_tmate_2ball())*/||ball_in_region()) {
  if ((player.unum==get_2ball.can_get2ball_fastest())||
      (ball_in_region())||(dist_2me(world.ball)<3)||
      (world.control_ball.getball)) {
    if (can_kickball()) {
      if (double_kick.possible()) double_kick.perform();
      else if (shoot2goal.possible()) shoot2goal.perform();
      else if (pass.possible()) pass.perform();
      else if (dribble.possible()) dribble.perform();
    } else {
/*      if (world.body.loc.x<world.offside.opp.line-2)
        get_2ball.perform();
      else if (player.unum==nearmost_player(world.ball, TMATES))*/
        get_2ball.perform();
    };
  } else {
    goto_playing_post.perform();
  };

  player_neck_behavior();
  player_view_behavior();
}

void kick_off_behavior(void)
{
  static int st = 0;

  if (LOG_BEHAVIOR) logmsg("Behavior : Player kick_off behavior acting.");


  if (st==0) st=6;
  if (st>0) st--;
  
  if (can_kickball()) {
    if (st==0) player_play_behavior();
    return;
  };

  if (player.side==play_mode_side(player.playmode)) {
    if (((!in_penalty_area(world.ball))
       ||(player.unum==GOALER_UNUM))
      &&((nearmost_player(world.ball, TMATES)==player.unum)
       ||(ball_in_region()))) get_2ball.perform();
    else goto_playing_post.perform();
  } else {
    if ((dist_2me(world.ball)>9.5)||(world.offside.inoff)||(client.role==GOALER)) goto_playing_post.perform();
  }
}
