#define _behaviors_defender_extern_
#include "defender.h"

//*****************************defender low level***********************
void defender_get2ball()
{
  if (LOG_BEHAVIOR) logmsg("Behavior : defender get_2ball acting.");
  get_2ball.perform();
}

void defender_support(double maxdash,int who)
{
  Command com2send;
  if (LOG_BEHAVIOR) logmsg("Behavior : defender_support acting.");
  get_2ball.move_2dest(com2send, 
      0.66*cos(Deg2Rad(direction(world.ball.x-(-GOAL_X),world.opp[who].y)))*dist2point(-GOAL_X,0,world.ball)-GOAL_X, 
      0.66*sin(Deg2Rad(direction(world.ball.x-(-GOAL_X),world.opp[who].y)))*dist2point(-GOAL_X,0,world.ball), 
      maxdash);
  perform_command(com2send);
/*debugging posponed

#ifdef DEBUG_ON
      sprintf(debugbuf,"--DEFEND : Move to x,y,dir : %.2f , %.2f , %.2f",
              0.66*cos(Deg2Rad(direction(world.ball.x-(-GOAL_X),world.ball.y)))*dist2point(-GOAL_X,0,world.ball)-GOAL_X,
              0.66*sin(Deg2Rad(direction(world.ball.x-(-GOAL_X),world.ball.y)))*dist2point(-GOAL_X,0,world.ball)
	      ,direction(world.ball.x-(-GOAL_X),world.ball.y));
      logmsg(debugbuf);
#endif      
*/
}

void block(int opponent,double maxdash)
{
  Command com2send;
  if (LOG_BEHAVIOR) logmsg("Behavior : block acting.");
  get_2ball.move_2dest(com2send, 
      world.opp[opponent].x-3, world.opp[opponent].y, maxdash);
  perform_command(com2send);
}

//*****************************defender mid level***********************
void safe_goto_pos(double x,double y)
{
  Command com2send; 
  static int last_safe_goto_pos;
  double down,up;
  if (world.ball.x>15.0){
    down=x+0.5;
    up=x+5;
  } else {
       down=x-6;
       up=x-3;
     }
  if (abs(last_safe_goto_pos-world.time.clock)<2){
    down=up=(down+up)/2;
    down=down-1;
    up=up+1;
  }
  if (dist2point(x,y,world.body.loc)<10){
    if ((world.body.loc.x>up)||(world.body.loc.x<down)){
/*debugging posponed
#ifdef DEBUG_ON
      sprintf(debugbuf,"--DEFEND :safe_goto_pos 2: %.2f , %.2f",x,world.body.loc.y);
      logmsg(debugbuf);
#endif      
*/
      get_2ball.move_2dest(com2send, x, world.body.loc.y, stamina_usage(2));
      perform_command(com2send);
      last_safe_goto_pos=world.time.clock;
    }
  }
  else{
/*debugging posponed
#ifdef DEBUG_ON
      sprintf(debugbuf,"--DEFEND :safe_goto_pos 4: %.2f , %.2f",x,y);
      logmsg(debugbuf);
#endif      
*/
      get_2ball.move_2dest(com2send, x, y, stamina_usage(4));
      perform_command(com2send);
      last_safe_goto_pos=world.time.clock;
  }
}

bool defender_block(int *playerduty, int who)
{
  int c=0,i,j,nearest2goal,blocker;
  double min_dist;
  int mark[N_PLAYER_PER_TEAM+1]={0,0,0,0,0,0,0,0,0,0,0,0};
  
  if (LOG_BEHAVIOR) logmsg("Behavior : defender_block acting.");
  for (i=2;i<=5;i++)
    if (playerduty[i]==0) c++;
  
  for(i=1;i<=c;i++) { 
    min_dist=FIELD_LENGTH;
    nearest2goal=0;
    for(j=1;j<=N_PLAYER_PER_TEAM;j++) {
      if ((j!=who)&&(mark[j]==0)
         &&(dist2point(-GOAL_X,0,world.opp[j])<dist2point(-GOAL_X,0,world.ball))
         &&(dist2point(world.ball.x,world.ball.y,world.opp[j])<35)) {
        if (dist2point(-GOAL_X,0,world.opp[j])<min_dist) {
	  nearest2goal = j;
	  min_dist=dist2point(-GOAL_X,0,world.opp[j]);
        }
      }
    }
    if (nearest2goal!=0) {
      mark[nearest2goal]=1;
      min_dist=FIELD_LENGTH;
      blocker=0;
      for(j=2;j<=5;j++) 
        if ((playerduty[j]!=0)&&(dist2point(world.tmate[j].x,world.tmate[j].y,world.opp[nearest2goal])<min_dist)) {
          blocker = j;
          min_dist=dist2point(world.tmate[j].x,world.tmate[j].y,world.opp[nearest2goal]);
        }
/* postponed
#ifdef DEBUG_ON
    sprintf(debugbuf,"nearest2goal %d blocker %d", nearest2goal,blocker);
    logmsg(debugbuf);
#endif
*/
      if (blocker!=0){
        playerduty[blocker] = 3;      
        if (blocker==player.unum) {
          block(nearest2goal,stamina_usage(4));
          return true;    
        }
      }
    }
  }
  return false;  
}

int best_defender_goto_ball(int *playerduty)
{
  int i,find_player;
  if (LOG_BEHAVIOR) logmsg("Behavior : best_defender_goto_ball acting.");
  for(i=1;i<=N_PLAYER_PER_TEAM;i++) 
{
    find_player=ith_nearmost_2ball(i);
    if ((arrange.player_role[find_player]==DEFEND)&&(dist2point(-GOAL_X,0,world.tmate[find_player])<
         dist2point(-GOAL_X,0,world.ball)) && (playerduty[find_player]==0))
	return(find_player);
  }
  return 0;
}

int best_defender_support(int *playerduty)
{
  int i,find_player;
    
  if (LOG_BEHAVIOR) logmsg("Behavior : best_defender_support acting.");
  for (i=1;i<=N_PLAYER_PER_TEAM;i++) {
    find_player=ith_nearmost_2ball(i);
/*
#ifdef DEBUG_ON
      sprintf(debugbuf,"best_defender :i %d ith  %d,duty[ith] %d",i,find_player,playerduty[find_player]);
      logmsg(debugbuf);
#endif      
*/
    if ((arrange.player_role[find_player]==DEFEND) &&((dist2point(-GOAL_X,0,world.tmate[find_player])<
           dist2point(-GOAL_X,0,world.ball))&&(playerduty[find_player]==0))) {
      playerduty[find_player]= 2; // should get the ball either
      return(find_player);
    }
  }
  return 0;
}
void normal_defender(int *playerduty)
{
  int i,j,t;
  double W=FIELD_WIDTH,fake_W=FIELD_WIDTH-20;
  double best_pos[4];
  int defend[4]={5,3,2,4};
  double ranges[5];
  double defend_care_range;
  if (world.ball.x>10) defend_care_range=8.0;
    else if (world.ball.x>-5) defend_care_range=4.0;
      else defend_care_range=0.0;
  for (j=0;j<5;j++)
    ranges[j]=(j-2.0)*fake_W/4;
  ranges[0]=-W/2;
  ranges[4]=W/2;
  
  for (j=0;j<4;j++)
    best_pos[j]=0;
  for (i=1;i<=N_PLAYER_PER_TEAM;i++)
    for (j=0;j<4;j++)
      if ((world.opp[i].y>=ranges[j]-2) && (world.opp[i].y<ranges[j+1]+2)) {
        if (best_pos[j]>world.opp[i].x) {
	  best_pos[j]=world.opp[i].x;
	  for (t=-3;t<=3;t++)
	    if ((t!=0) && (t+j>=0) && (t+j<=3) 
	       && (best_pos[t+j]>best_pos[j]+fabs(defend_care_range*t))) {	      
	       best_pos[t+j]=best_pos[j]+fabs(defend_care_range*t);
	    }	    
	}
      }
  for (j=0;j<4;j++) {
    playerduty[defend[j]]=4;
    if (best_pos[j]>0) best_pos[j]=0;
    if (defend[j]==player.unum)
      safe_goto_pos(best_pos[j],(j-2)*fake_W/4+fake_W/8);
  }
}
//*****************************defender high level***********************

void defender_play_behavior(void)
{
  Command com2send;
  int who,player_find;
  int playerduty[6]={0,0,0,0,0,0};
  int funcID=-1;
  char debugmsg[100];

  if (LOG_BEHAVIOR) {
    sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
    logmsg(debugmsg);
  }
/*
#ifdef DEBUG_ON
      sprintf(debugbuf,"Near2ball %d",
         nearmost_player_2ball());
      logmsg(debugbuf);
      sprintf(debugbuf,"fastest2ball %d",
         can_get2ball_fastest());
      logmsg(debugbuf);
#endif      
*/  
  if (LOG_BEHAVIOR) logmsg("Behavior : defender play_on behavior acting.");
  
  if (can_kickball()) {
    funcID=0;
    if (double_kick.possible()) double_kick.perform();
    else if (shoot2goal.possible()) shoot2goal.perform();
    else if (pass.possible()) pass.perform();
    else if (dribble.possible()) dribble.perform();
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return;
  }
    
  who = nearmost_player(world.ball.x, world.ball.y, ALLPLAYERS, INCLUDE_ME, 6);
  if(speed(world.ball) > 1.0)
    who=0;
  if (LOG_BEHAVIOR) {
    sprintf(debugmsg, "Defender Behavior : who? %d", who);
    logmsg(debugmsg);
  }
/*
#ifdef DEBUG_ON
      sprintf(debugbuf,"--DEFEND : who carry the ball : %d",who);
      logmsg(debugbuf);
#endif      
*/  
  // we are carrying the ball
  if ((world.ball.x+20*world.ball.vx>0) && (world.ball.x>15)){
    funcID=1;
    normal_defender(playerduty);
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return;
  }
  
  if ((world.ball.x>0)||((world.ball.x-world.body.loc.x>15)&&(world.ball.x>-15))){
    if (get_2ball.can_get2ball_fastest()==player.unum) {
       get_2ball.perform();
       funcID=2;
    }
     else {
       normal_defender(playerduty);
       funcID=3;
    }
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return;
  }
    
  if (who>0){
    if (get_2ball.can_get2ball_fastest()==player.unum){
       get_2ball.perform();
       funcID=4;
    } 
    else 
      goto_playing_post.perform();    
    funcID=5;
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return;
  }
  // ball is somewhere
  if (who==0) {
    if (get_2ball.can_get2ball_fastest()<6) playerduty[get_2ball.can_get2ball_fastest()]= 1; // should get the ball
    if (get_2ball.can_get2ball_fastest()==player.unum) {
      funcID=6;
      defender_get2ball();
    } else {
      if (!defender_block(playerduty,who)) 
        funcID=7;
        goto_playing_post.perform();	   	 
    }
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return;
  }
  
  who*=-1;
  // apponent is carrying the ball!!! DANGER!!
  //  if (world.ball.x<-15) {
    int nearmost_player_2ball=nearmost_player(world.ball, TMATES, INCLUDE_ME);
    if ( (nearmost_player_2ball < 6) && (nearmost_player_2ball > 0) )
       playerduty[nearmost_player_2ball]= 1; // should get the ball
    if (nearmost_player_2ball==player.unum) {
      defender_get2ball();
      funcID=8;
      if (LOG_BEHAVIOR) {
        sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
        logmsg(debugmsg);
      }
      return;
    } else {
      //if best defender to ball
      if (dist2point(-GOAL_X,0,world.tmate[nearmost_player_2ball])>
          dist2point(-GOAL_X,0,world.opp[who])) {
        player_find=best_defender_goto_ball(playerduty);
        if (player_find!=0){
          playerduty[player_find]=1;
          if (player_find==player.unum){
            defender_get2ball();
            funcID=9;
            if (LOG_BEHAVIOR) {
              sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
              logmsg(debugmsg);
            }
            return;
          }
	}
      }
      player_find=best_defender_support(playerduty);
      if (player_find!=0) playerduty[player_find]=2;
      if (player_find==player.unum) {
        defender_support(stamina_usage(4),who);
        funcID=10;
        if (LOG_BEHAVIOR) {
          sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
          logmsg(debugmsg);
        }
	return;
      }
    }
    if (!defender_block(playerduty,who)) 
      if (dist2point(-GOAL_X,0,world.body.loc)>
dist2point(-GOAL_X,0,world.ball)) {
          get_2ball.move_2dest(com2send, -GOAL_X,0,stamina_usage(5));	   	 
          perform_command(com2send);
	  funcID=11;
      } else 
         goto_playing_post.perform();
    funcID=12;
    if (LOG_BEHAVIOR) {
      sprintf(debugmsg, "Defender Behavior : funcID: %d", funcID);
      logmsg(debugmsg);
    }
    return; 
//  }  
} // end of proc.     
