#define HALF_PITCH_L		PITCH_LENGTH/2.0 
#define HALF_PITCH_W		PITCH_WIDTH/2.0 
#define PENALTY_CORNER_X	(HALF_PITCH_L - PENALTY_AREA_LENGTH)
#define PENALTY_CORNER_Y	(PENALTY_AREA_WIDTH/2.0)
#define HALF_PITCH_L_M		(HALF_PITCH_L + 5)
#define HALF_PITCH_W_M		(HALF_PITCH_W + 5)

typedef enum {
	FP_c,
	FP_c_t,
	FP_c_b,
	FP_l_t,
	FP_l_b,
	FP_r_t,
	FP_r_b,
	FP_p_l_t,
	FP_p_l_c,
	FP_p_l_b,
	FP_p_r_t,
	FP_p_r_c,
	FP_p_r_b,
	FP_g_l_t,
	FP_g_l_b,
	FP_g_r_t,
	FP_g_r_b,
	FP_t_l_50,
	FP_t_l_40,
	FP_t_l_30,
	FP_t_l_20,
	FP_t_l_10,
	FP_t_0,
	FP_t_r_10,
	FP_t_r_20,
	FP_t_r_30,
	FP_t_r_40,
	FP_t_r_50,
	FP_b_l_50,
	FP_b_l_40,
	FP_b_l_30,
	FP_b_l_20,
	FP_b_l_10,
	FP_b_0,
	FP_b_r_10,
	FP_b_r_20,
	FP_b_r_30,
	FP_b_r_40,
	FP_b_r_50,
	FP_l_t_30,
	FP_l_t_20,
	FP_l_t_10,
	FP_l_0,
	FP_l_b_10,
	FP_l_b_20,
	FP_l_b_30,
	FP_r_t_30,
	FP_r_t_20,
	FP_r_t_10,
	FP_r_0,
	FP_r_b_10,
	FP_r_b_20,
	FP_r_b_30,
	FP_Unknown,
	FP_,
	FP__MAX
} FlagPos ;

#define FLAGINFOTAB	{\
  {"c", FP_c, {              0.0,                0.0}},\
  {"c t", FP_c_t, {              0.0,      -HALF_PITCH_W} },\
  {"c b", FP_c_b, {              0.0,       HALF_PITCH_W} },\
  {"l t", FP_l_t, {    -HALF_PITCH_L,      -HALF_PITCH_W} },\
  {"l b", FP_l_b, {    -HALF_PITCH_L,       HALF_PITCH_W} },\
  {"r t", FP_r_t, {     HALF_PITCH_L,      -HALF_PITCH_W} },\
  {"r b", FP_r_b, {     HALF_PITCH_L,       HALF_PITCH_W} },\
  {"p l t", FP_p_l_t, {-PENALTY_CORNER_X,  -PENALTY_CORNER_Y} },\
  {"p l c", FP_p_l_c, {-PENALTY_CORNER_X,                0.0} },\
  {"p l b", FP_p_l_b, {-PENALTY_CORNER_X,   PENALTY_CORNER_Y} },\
  {"p r t", FP_p_r_t, { PENALTY_CORNER_X,  -PENALTY_CORNER_Y} },\
  {"p r c", FP_p_r_c, { PENALTY_CORNER_X,                0.0} },\
  {"p r b", FP_p_r_b, { PENALTY_CORNER_X,   PENALTY_CORNER_Y} },\
  {"g l t", FP_g_l_t, {    -HALF_PITCH_L,    -GOAL_WIDTH/2.0}},\
  {"g l b", FP_g_l_b, {    -HALF_PITCH_L,     GOAL_WIDTH/2.0}},\
  {"g r t", FP_g_r_t, {     HALF_PITCH_L,    -GOAL_WIDTH/2.0}},\
  {"g r b", FP_g_r_b, {     HALF_PITCH_L,     GOAL_WIDTH/2.0}},\
  {"t l 50", FP_t_l_50, {              -50,    -HALF_PITCH_W_M}},\
  {"t l 40", FP_t_l_40, {              -40,    -HALF_PITCH_W_M}},\
  {"t l 30", FP_t_l_30, {              -30,    -HALF_PITCH_W_M}},\
  {"t l 20", FP_t_l_20, {              -20,    -HALF_PITCH_W_M}},\
  {"t l 10", FP_t_l_10, {              -10,    -HALF_PITCH_W_M}},\
  {"t 0", FP_t_0, {                0,    -HALF_PITCH_W_M}},\
  {"t r 10", FP_t_r_10, {               10,    -HALF_PITCH_W_M}},\
  {"t r 20", FP_t_r_20, {               20,    -HALF_PITCH_W_M}},\
  {"t r 30", FP_t_r_30, {               30,    -HALF_PITCH_W_M}},\
  {"t r 40", FP_t_r_40, {               40,    -HALF_PITCH_W_M}},\
  {"t r 50", FP_t_r_50, {               50,    -HALF_PITCH_W_M}},\
  {"b l 50", FP_b_l_50, {              -50,     HALF_PITCH_W_M}},\
  {"b l 40", FP_b_l_40, {              -40,     HALF_PITCH_W_M}},\
  {"b l 30", FP_b_l_30, {              -30,     HALF_PITCH_W_M}},\
  {"b l 20", FP_b_l_20, {              -20,     HALF_PITCH_W_M}},\
  {"b l 10", FP_b_l_10, {              -10,     HALF_PITCH_W_M}},\
  {"b 0", FP_b_0, {                0,     HALF_PITCH_W_M}},\
  {"b r 10", FP_b_r_10, {               10,     HALF_PITCH_W_M}},\
  {"b r 20", FP_b_r_20, {               20,     HALF_PITCH_W_M}},\
  {"b r 30", FP_b_r_30, {               30,     HALF_PITCH_W_M}},\
  {"b r 40", FP_b_r_40, {               40,     HALF_PITCH_W_M}},\
  {"b r 50", FP_b_r_50, {               50,     HALF_PITCH_W_M}},\
  {"l t 30", FP_l_t_30, {  -HALF_PITCH_L_M,                -30}},\
  {"l t 20", FP_l_t_20, {  -HALF_PITCH_L_M,                -20}},\
  {"l t 10", FP_l_t_10, {  -HALF_PITCH_L_M,                -10}},\
  {"l 0", FP_l_0, {  -HALF_PITCH_L_M,                  0}},\
  {"l b 10", FP_l_b_10, {  -HALF_PITCH_L_M,                 10}},\
  {"l b 20", FP_l_b_20, {  -HALF_PITCH_L_M,                 20}},\
  {"l b 30", FP_l_b_30, {  -HALF_PITCH_L_M,                 30}},\
  {"r t 30", FP_r_t_30, {   HALF_PITCH_L_M,                -30}},\
  {"r t 20", FP_r_t_20, {   HALF_PITCH_L_M,                -20}},\
  {"r t 10", FP_r_t_10, {   HALF_PITCH_L_M,                -10}},\
  {"r 0", FP_r_0, {   HALF_PITCH_L_M,                  0}},\
  {"r b 10", FP_r_b_10, {   HALF_PITCH_L_M,                 10}},\
  {"r b 20", FP_r_b_20, {   HALF_PITCH_L_M,                 20}},\
  {"r b 30", FP_r_b_30, {   HALF_PITCH_L_M,                 30}},\
  {"Unknown", FP_Unknown, {              0.0,                0.0} },\
  {"", FP_, {              0.0,                0.0} },\
  {NULL}}


typedef struct {
  char* namestr ;
  FlagPos name ;
  Pos pos ;
} FlagInfo ;

