/*
  SKILLS : HEADER FILE
  
  Skills utilities: 
    kick ball to reach a location
    kick ball with a power in a direction
    kick ball to get to a velocity
    do effective turn

  Ehsan Foroughi 

  ParsAI Team
  Sharif University of Tech.

 */

#ifndef _SKILLS_UTILS_H
#define _SKILLS_UTILS_H

#ifndef _skills_utils_extern_
#define _skills_utils_extern_ extern
#endif

#include "../headers.h"

_skills_utils_extern_ double needed_vx4kick(double x, double y, double fv);

_skills_utils_extern_ double needed_vy4kick(double x, double y, double fv);


_skills_utils_extern_ bool kick2location(Command &com, double x, double y, double fv);

_skills_utils_extern_ bool one_cycle_kick2location(Command &com, double x, double y);

_skills_utils_extern_ bool kick2direction(Command &com, double dir, double kickpower);

_skills_utils_extern_ bool kick2velocity(Command &com, double dir, double sp);

_skills_utils_extern_ double effective_turn(double dir);

_skills_utils_extern_ void spin(Command &com, int rotate); 
_skills_utils_extern_ void spin_2dir(Command &com, double dir);
_skills_utils_extern_ void spin_to(Command &com, double dir,double dist);
_skills_utils_extern_ double point_2line_dist(double x1,double y1,double x2,double y2,double x3,double y3);

_skills_utils_extern_ void spin_kick(Command &com, double dir);

_skills_utils_extern_ double fuzzy(double x,double a,double b);
_skills_utils_extern_ bool solve(double a,double b,double c,double &answer);

_skills_utils_extern_ bool is_in_field(double x, double y);
_skills_utils_extern_ bool is_in_field(Objpos &p);

#endif
