/*
  HEADER FILE
  
  Low level utilities: 
    random functions
    relative cordination functions
    angle calculation functions

  Ehsan Foroughi 
  ParsAI Team
  Sharif University of Tech.

 */

#ifndef _UTILS_H
#define _UTILS_H

#ifndef _utils_extern_
#define _utils_extern_ extern
#endif

#include "headers.h"

_utils_extern_ void swap(int &x,int &y);
_utils_extern_ void swap(double &x,double &y);

_utils_extern_ int genrand(int n);

_utils_extern_ bool equal_float(double a,double b);

_utils_extern_ bool equal_dist(double a, double b);

_utils_extern_ double normalize_angle(double angle);
_utils_extern_ double diff_angle(double ang1, double ang2);

_utils_extern_ double dist(double dx, double dy);
_utils_extern_ double dist(Objpos &pos, double x, double y);
_utils_extern_ double dist(Pos &pos, Objpos &obj);
_utils_extern_ double dist(Objpos &pos, Objpos &obj);

_utils_extern_ double dist2point(double px,double py,Objpos &obj);
_utils_extern_ double dist2point(Objpos &objs,Objpos &objd);

_utils_extern_ double dist_2me(double x, double y);

_utils_extern_ double dist_2me(Objpos &obj);

_utils_extern_ double direction(double dx, double dy);
_utils_extern_ double direction(Objpos &objs,Objpos &objd);

_utils_extern_ double dir_from_me(double x, double y);
_utils_extern_ double dir_from_me(Objpos &obj);

_utils_extern_ double reldir_2me(double x, double y);

_utils_extern_ double reldir_2me(Objpos &obj);

_utils_extern_ double relviewdir_2me(double x, double y);

_utils_extern_ double relviewdir_2me(Objpos &obj);

_utils_extern_ double speed(Objpos &obj);

_utils_extern_ void com_turn(Command &com, double moment);
_utils_extern_ void com_dash(Command &com, double power);
_utils_extern_ void com_kick(Command &com, double power, double dir);

_utils_extern_ bool is_play_on(void);

_utils_extern_ Side play_mode_side(PlayMode p);

_utils_extern_ bool str_play_mode(PlayMode p, char *str);
_utils_extern_ bool kick_play_mode(void);

#endif /* !_UTILS_H */
