#define _world_fullstate_extern_
#include "fullstate.h"

void get_fullstate_info(char *fsmsg)
{
  Objpos *obj;
  char *s;
  char c;
  int n, i;
  s = fsmsg;
  n = sscanf(s, "(fullstate %d", &(fullstate.time.clock));
  assert(n==1);
  nextopran(s);
  n = sscanf(s, "(pmode %[^)]", fullstate.playmodestr);
  assert(n==1);
  nextopran(s);
  nexttoken(s);
  if (!strncmp(s,"high",4)) fullstate.view.quality = VQ_high;
  else if (!strncmp(s,"low",3)) fullstate.view.quality = VQ_low;
  nexttoken(s);
  if (!strncmp(s,"narrow",6)) fullstate.view.width = VW_Narrow;
  else if (!strncmp(s,"normal",6)) fullstate.view.width = VW_Normal;
  else if (!strncmp(s,"wide",4)) fullstate.view.width = VW_Wide;
  nextopran(s);
  if (player.side==S_LEFT)
    n = sscanf(s, "(score %d %d)", &(fullstate.score.ourscore), &(fullstate.score.oppscore));
  else 
    n = sscanf(s, "(score %d %d)", &(fullstate.score.oppscore), &(fullstate.score.ourscore));
  assert(n==2);
  nextopran(s);
  n = sscanf(s, "(ball %lf %lf %lf %lf)", 
    &(fullstate.ball.x), 
    &(fullstate.ball.y), 
    &(fullstate.ball.vx), 
    &(fullstate.ball.vy));
  assert(n==4);
  nextopran(s);
  while (*s!=0) {
    n = sscanf(s, "(%c_%d", &c, &i);
    assert(n==2);
    if ((c=='l')^(player.side==S_RIGHT)) obj = &fullstate.tmate[i];
    else obj = &fullstate.opp[i];
    n = sscanf(s, "(%c_%d %lf %lf %lf %lf %lf %lf %lf", 
      &c,
      &i,
      &(obj->x), 
      &(obj->y), 
      &(obj->vx), 
      &(obj->vy), 
      &(obj->body_dir), 
      &(obj->face_dir), 
      &(obj->stamina));
    assert(n==9);
    nextopran(s);
  };
  refresh_fullstate_log();
}

void refresh_fullstate_log(void)
{
  static double m = 0;
  static double t = 0;
  char s[100];
  if (!LOG_FULLSTATE) return;
  if (world.time.clock < 5) return;
  if (dist_2me(world.ball) > 20) return;
  m += dist((world.body.loc.x-world.ball.x) - (fullstate.tmate[player.unum].x-fullstate.ball.x),
            (world.body.loc.y-world.ball.y) - (fullstate.tmate[player.unum].y-fullstate.ball.y));
  t++;
  sprintf(s, "Mean error is %lf", m/t);
  logmsg(s);
}
