#ifndef WORLD_PARAMS_H
#define WORLD_PARAMS_H

#define MAX_PLAYER_TYPES   7

#ifndef _world_params_extern_
#define _world_params_extern_ extern
#endif

#include "../headers.h"

typedef struct _server_params {
  double gwidth;				/* goal width */
  double inertia_moment;			/* intertia moment for turn */
  double psize;					/* player size */
  double pdecay;				/* player decay */
  double prand;					/* player rand */
  double pweight;				/* player weight */
  double pspeed_max;				/* player speed max */
  double paccel_max;				/* player acceleration max */
  double stamina_max;				/* player stamina max */
  double stamina_inc;				/* player stamina inc */
  double recover_init;				/* player recovery init */
  double recover_dthr;				/* player recovery decriment threshold */
  double recover_min;				/* player recovery min */
  double recover_dec;				/* player recovery decriment */
  double effort_init;				/* player dash effort init */
  double effort_dthr;				/* player dash effort decriment threshold */
  double effort_min;				/* player dash effort min */
  double effort_dec;				/* player dash effort decriment */
  double effort_ithr;				/* player dash effort incriment threshold */
  double effort_inc;				/* player dash effort incriment */
  double kick_rand;                             /* noise added directly to kicks */
  int team_actuator_noise;                      /* flag whether to use team specific actuator noise */
  double prand_factor_l;                        /* factor to multiple prand for left team */
  double prand_factor_r;                        /* factor to multiple prand for right team */
  double kick_rand_factor_l;                    /* factor to multiple kick_rand for left team */
  double kick_rand_factor_r;                    /* factor to multiple kick_rand for right team */
  double bsize;					/* ball size */
  double bdecay;				/* ball decay */
  double brand;					/* ball rand */
  double bweight;				/* ball weight */
  double bspeed_max;				/* ball speed max */
  double baccel_max;				/* ball acceleration max */
  double dprate;				/* dash power rate */
  double kprate;				/* kick power rate */
  double kmargin;				/* kickable margin */
  double ctlradius;				/* control radius */
  double ctlradius_width;			/* (control radius) - (plyaer size) */
  double maxp;					/* max power */
  double minp;					/* min power */
  double maxm;					/* max moment */
  double minm;					/* min moment */
  double maxnm;					/* max neck moment */
  double minnm;					/* min neck moment */
  double maxn;					/* max neck angle */
  double minn;					/* min neck angle */
  double visangle;				/* visible angle */
  double visdist;				/* visible distance */
  double windir;				/* wind direction */
  double winforce;				/* wind force */
  double winang;				/* wind angle for rand */
  double winrand;				/* wind force for force */
  double kickable_area;				/* kickable_area */
  double catch_area_l;				/* goalie catchable area length */
  double catch_area_w;				/* goalie catchable area width */
  double catch_prob;				/* goalie catchable possibility */
  int   goalie_max_moves;                 	/* goalie max moves after a catch */	
  double ckmargin;				/* corner kick margin */
  double offside_area;				/* offside active area size */
  int win_no;					/* wind factor is none */
  int win_random;				/* wind factor is random */
/*
  int portnum;					// port number
  int coach_pnum;				// coach port number
  int olcoach_pnum;				// online coach port number
*/
  int say_cnt_max;				// max count of coach SAY (freeform)
  int SayCoachMsgSize;				// max length of coach SAY (freeform)
/*
  int clang_win_size;                           // coach language: time window size
  int clang_define_win;                         // coach language: define messages per window
  int clang_meta_win;                           // coach language: meta messages per window
  int clang_advice_win;                         // coach language: advice messages per window
  int clang_info_win;                           // coach language: info messages per window
  int clang_mess_delay;                         // coach language: delay between receive and send
  int clang_mess_per_cycle;                     // coach language: number of messages to flush per cycle
*/
  int half_time;				// half time
//  int drop_time;                                // 0 means don't drop automatically
} server_params;

typedef struct _player_params {
  
} player_params;

typedef struct _player_type {
  double player_speed_max;
  double stamina_inc_max;
  double player_decay;
  double inertia_moment;
  double dash_power_rate;
  double player_size;
  double kickable_margin;
  double kick_rand;
  double extra_stamina;
  double effort_max;
  double effort_min;
} player_type;

_world_params_extern_ struct {
  server_params server;
  player_params player;
  player_type types[MAX_PLAYER_TYPES];
} params;

_world_params_extern_ void init_params(void);

_world_params_extern_ void get_params(ParamInfo &params);

#endif
