#ifndef WORLD_TYPES_H
#define WORLD_TYPES_H

#include "../player.h"

typedef struct _PVector {
  double val, ang;
} PVector;

typedef enum {
  GOALER = 0,
  DEFEND,
  MIDDLE,
  ATTACK,
  COACH,
} Role;

typedef struct _Time {
  int clock,
      stopped;
} Time;

typedef struct _ViewState {
  ViewQuality quality;
  ViewWidth width;
} ViewState;

typedef struct _Score {
  int ourscore, oppscore;
} Score;

typedef struct _Objpos {
  double x, y;
  double body_dir, face_dir;
  double vx, vy;
  double stamina;
  double correctness;     // correctness : reliability (in percentage)
  Time update_time;
} Objpos;

typedef struct _offdata {
  double line;
  int unum;
  bool offpos;    // got offside position from opponent
} offdata;

typedef struct _Counter {
  int kick;
  int dash;
  int turn;
  int say;
  int turnneck;
  int gcatch;
  int move;
  int change_view;
} Counter;

typedef enum {
  NO_COMMAND,
  KICK,
  DASH,
  TURN,
} CommandType;

typedef enum {
  INCLUDE_ME,
  EXCLUDE_ME,
} SearchInclude;

typedef enum {
  TMATES,
  OPPONENTS,
  ALLPLAYERS,
} SearchPlayers;

typedef struct _Command {
  CommandType type;
  double par1, par2;
  double neck_moment;
  int clock;
  bool ack;
} Command;

#endif
