#define _world_utils_extern_
#include "utils.h"

int nearmost_player(double x, double y, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000)
{
  int i, m = 0;
  for(i=((pl!=OPPONENTS)?1:(N_PLAYER_PER_TEAM+1));i<=((pl==TMATES)?(N_PLAYER_PER_TEAM):(2*N_PLAYER_PER_TEAM));i++)
    if ((i!=player.unum)||(incl==INCLUDE_ME))
      if (dist(x-moving_obj_possys(i).x,y-moving_obj_possys(i).y)<maxdist) {
        if (m==0) m = i; 
	else if (dist(x-moving_obj_possys(i).x,y-moving_obj_possys(i).y)<
                 dist(x-moving_obj_possys(m).x,y-moving_obj_possys(i).y)) m = i;
      };
  return m;
}

int nearmost_player(Pos &pos, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000)
{
  return nearmost_player(pos.x, pos.y, pl, incl, maxdist);
}

int nearmost_player(Objpos &pos, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000)
{
  return nearmost_player(pos.x, pos.y, pl, incl, maxdist);
}

bool isin_2nearmost_2ball(void)
{
  int i, m, j;
  j = nearmost_player(world.ball, TMATES);
  if (j==player.unum) return true;
  m = j;
  for(i=1;i<=N_PLAYER_PER_TEAM;i++)
    if (i!=j)
      if (dist(world.ball.x-world.tmate[i].x,world.ball.y-world.tmate[i].y)<
          dist(world.ball.x-world.tmate[m].x,world.ball.y-world.tmate[m].y))
        m = i;
  return (m==player.unum);
}

int ith_nearmost_2ball(int i)
{
  int m, j,small;
  int a[N_PLAYER_PER_TEAM+1];
  for (j=1;j<=N_PLAYER_PER_TEAM;j++)
    a[j]=j;
  
  for (j=1;j<=N_PLAYER_PER_TEAM;j++){
    small=j;
    for(m=j+1;m<=N_PLAYER_PER_TEAM;m++){
        if (dist(world.ball.x-world.tmate[a[small]].x,world.ball.y-world.tmate[a[small]].y)>
	    dist(world.ball.x-world.tmate[a[m]].x,world.ball.y-world.tmate[a[m]].y)) small=m;
    }
    swap(a[small],a[j]);
  }
  return (a[i]);
}

/*
int nearmost_forward_player(void)
{
  int i, m = player.unum;
  for(i=1;i<=N_PLAYER_PER_TEAM;i++)
    if ((world.tmate[i].x>(world.body.loc.x+1))&&(dist_2me(world.tmate[i])>5)) {
      if (dist_2me(world.tmate[i])<dist_2me(world.tmate[m])) m=i;
      if (m==player.unum) m=i;
    };
  return m;
}*/

double free_dist_cone(double dir)
{
  int i;
  double c = FIELD_WIDTH;
  for(i=1;i<=N_PLAYER_PER_TEAM;i++)
    if (fabs(normalize_angle(dir_from_me(world.opp[i].x,world.opp[i].y)-dir))<CONE_ANGLE)
      if (dist_2me(world.opp[i])<c)
        c = dist_2me(world.opp[i]);
  return c;
}

double free_dist_circle(void)
{
  int i;
  double c = FIELD_WIDTH;
  for(i=1;i<=N_PLAYER_PER_TEAM;i++)
    if (dist_2me(world.opp[i])<c)
      c = dist_2me(world.opp[i]);
  for(i=1;i<=N_PLAYER_PER_TEAM;i++)
    if (i!=player.unum)
      if (dist_2me(world.tmate[i])<c)
        c = dist_2me(world.tmate[i]);
  return c;
}

bool can_kickball(void)
{
  return(dist_2me(world.ball)<KICKABLE_AREA);
}

bool can_catch(void)
{
   if (player.playmode!=PM_play_on) return false;
   if (timeval(world.time)-timeval(world.body.last_catch)<5) return false;
   if (dist_2me(world.ball)>CATCHABLE_AREA_L) return false;
   if (dist_2me(world.ball)<CATCHABLE_AREA_L-0.2) return true;
   return (dist_2me(world.ball)<dist_2me(estimate_ball_x(1),estimate_ball_y(1)));
}

// Checked : OK (5/5)
double get_vx(double x, double y, double dist_chng, double dir_chng)
{
  double px, py, ds, t;
  px = x-world.body.loc.x;
  py = y-world.body.loc.y;
  ds = dist_2me(x,y);
  t = -dir_chng*(M_PI/180)*py;
  t += dist_chng*(px/ds);
  t += world.body.loc.vx;
  return(t);
}

// Checked : OK (5/5)
double get_vy(double x, double y, double dist_chng, double dir_chng)
{
  double px, py, ds, t;
  px = x-world.body.loc.x;
  py = y-world.body.loc.y;
  ds = dist_2me(x,y);
  t = dir_chng*(M_PI/180)*px;
  t += dist_chng*(py/ds);
  t += world.body.loc.vy;
  return(t);
}

// Checked : OK (4/5)
double estimate_ball_x(int turns)
{
  double t, vx;
  int i;
  vx = world.ball.vx;
  t = world.ball.x;
  for(i=0;i<turns;i++) {
    t += vx;
    vx *= BALL_DECAY;
  };
  return(t);
}

// Checked : OK (4/5)
double estimate_ball_y(int turns)
{
  double t, vy;
  int i;
  vy = world.ball.vy;
  t = world.ball.y;
  for(i=0;i<turns;i++) {
    t += vy;
    vy *= BALL_DECAY;
  };
  return(t);
}

// Checked : OK (4/5)
double estimate_player_x(Objpos &obj, int turns)
{
  double t, vx;
  int i;
  vx = obj.vx;
  t = obj.x;
  for(i=0;i<turns;i++) {
    t += vx;
    vx *= PLAYER_DECAY;
  };
  return(t);
}

// Checked : OK (4/5)
double estimate_player_y(Objpos &obj, int turns)
{
  double t, vy;
  int i;
  vy = obj.vy;
  t = obj.y;
  for(i=0;i<turns;i++) {
    t += vy;
    vy *= PLAYER_DECAY;
  };
  return(t);
}

double estimate_mypos_x(int turns)
{
/*  double t, vx;
  int i;
  vx = world.body.loc.vx;
  t = world.body.loc.x;
  for(i=0;i<turns;i++) {
    t += vx;
    vx *= PLAYER_DECAY;
  };
  return(t);*/
  return (estimate_player_x(world.body.loc,turns));
}

double estimate_mypos_y(int turns)
{
/*  double t, vy;
  int i;
  vy = world.body.loc.vy;
  t = world.body.loc.y;
  for(i=0;i<turns;i++) {
    t += vy;
    vy *= PLAYER_DECAY;
  };
  return(t);*/
  return (estimate_player_y(world.body.loc,turns));
}

bool in_penalty_area(double x, double y)
{
  return ( ((x<-PENALTY_CORNER_X)&& (fabs(y)<PENALTY_CORNER_Y)) ||
          ((x>PENALTY_CORNER_X)&& (fabs(y)<PENALTY_CORNER_Y)));
}

bool in_penalty_area(Objpos &obj)
{
   return in_penalty_area(obj.x,obj.y);
}

bool collide(Command &com)
{
  double vx, vy, x, y;
  double power_rate;
  double power, dir;
  
  if (com.type!=KICK) return false;

  power = com.par1;
  dir = com.par2;

  power_rate = KICK_POWER_RATE * (1 - 0.25 * fabs(reldir_2me(world.ball))/180
     - 0.25 * (dist_2me(world.ball)-PLAYER_SIZE-BALL_SIZE)/KICKABLE_MARGIN);
  vx = world.ball.vx + power*power_rate*cos(Deg2Rad(dir+world.body.loc.body_dir));
  vy = world.ball.vy + power*power_rate*sin(Deg2Rad(dir+world.body.loc.body_dir));
  x = world.ball.x + vx;
  y = world.ball.y + vy;
  return (dist(world.body.loc.x-x,world.body.loc.y-y)<PLAYER_SIZE+BALL_SIZE);
}

double view_angle(void)
{
  double ang=VIEW_ANGLE;
  if (world.view.width==VW_Narrow) ang/=2;
  if (world.view.width==VW_Wide) ang*=2;
  return ang;
}

double dist2goal(Objpos &pos)
{
  if (fabs(pos.y)<GOAL_HIGH_Y) return (GOAL_X-pos.x);
  else return dist(pos,GOAL_X,(pos.y>GOAL_HIGH_Y)?GOAL_HIGH_Y:GOAL_LOW_Y);
}

double stamina_usage(int priority)
{
  int pln = get_2ball.can_get2ball_fastest();

  if ((priority==5)&&(client.role!=GOALER))
    if (pln != player.unum) priority = 4;

  if ((priority>4)&&(in_penalty_area(world.body.loc))) priority = 6;

/*  if ((priority==5)&&(client.role!=GOALER))
    if ((player.unum!=pln)
      &&(get_2ball.who_controls_ball()>0)) {
      if (dist_2me(world.tmate[pln])<3) priority = 2;
      else priority = 4;
    }*/

  return stamina_usage(priority, world.body.stamina);
}

double stamina_usage(int priority, double stamina)
{
  double st = 80;

  if (priority==6) {
    if (stamina>300) st = 100;
    else st = 35;  
  } else if (priority==5) {
    if (stamina>2000) st = 100;
    else if (stamina>1500) st = 75;
    else if (stamina>1200) st = 50;
    else if (stamina>1000) st = 40;
    else if (stamina>800) st = 30;
    else if (stamina>500) st = 10;
    else st = 5;
  } else if (priority==4) {
    if (stamina>2000) st = 80;
    else if (stamina>1500) st = 65;
    else if (stamina>1200) st = 45;
    else if (stamina>1000) st = 35;
    else if (stamina>800) st = 25;
    else if (stamina>500) st = 10;
    else st = 5;
  } else if (priority==3) {
    if (stamina>2000) st = 65;
    else if (stamina>1500) st = 50;
    else if (stamina>1200) st = 40;
    else if (stamina>1000) st = 30;
    else if (stamina>800) st = 25;
    else if (stamina>500) st = 15;
    else st = 5;
  } else if (priority==2) {
    if (stamina>2500) st = 50;
    else if (stamina>2000) st = 40;
    else if (stamina>1500) st = 30;
    else if (stamina>1200) st = 20;
    else st = 5;
  }

  if (st<5) st = 5;
  return st;
}
