#ifndef WORLD_UTILS_H
#define WORLD_UTILS_H

#ifndef _world_utils_extern_
#define _world_utils_extern_ extern
#endif

#include "../headers.h"

#define nextopran(x) {if (*x!=0) x++; while((*x!='(')&&(*x!=0)) x++;}
#define nextcpran(x) {if (*x!=0) x++; while((*x!=')')&&(*x!=0)) x++;}
#define nextseptoken(x,sep) {while((*x!=sep)&&(*x!=0)) x++; if (*x!=0) x++;}
#define nexttoken(x) nextseptoken(x,' ')
#define skiptokens(x,y) {for(int i=0; i<y; i++) nexttoken(x);}

_world_utils_extern_ int nearmost_player(double x, double y, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000);
_world_utils_extern_ int nearmost_player(Pos &pos, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000);
_world_utils_extern_ int nearmost_player(Objpos &pos, SearchPlayers pl, SearchInclude incl = INCLUDE_ME, double maxdist = 1000);

_world_utils_extern_ bool isin_2nearmost_2ball(void);
_world_utils_extern_ int ith_nearmost_2ball(int i);

_world_utils_extern_ double free_dist_cone(double dir);
_world_utils_extern_ double free_dist_circle(void);

_world_utils_extern_ bool can_kickball(void);
_world_utils_extern_ bool can_catch(void);

_world_utils_extern_ bool in_penalty_area(double x, double y);
_world_utils_extern_ bool in_penalty_area(Objpos &obj);

_world_utils_extern_ double estimate_ball_x(int turns);
_world_utils_extern_ double estimate_ball_y(int turns);

_world_utils_extern_ double get_vx(double x, double y, double dist_chng, double dir_chng);
_world_utils_extern_ double get_vy(double x, double y, double dist_chng, double dir_chng);

_world_utils_extern_ double estimate_player_x(Objpos &obj, int turns);
_world_utils_extern_ double estimate_player_y(Objpos &obj, int turns);

_world_utils_extern_ double estimate_mypos_x(int turns);
_world_utils_extern_ double estimate_mypos_y(int turns);

_world_utils_extern_ bool collide(Command &com);

_world_utils_extern_ double view_angle(void);

_world_utils_extern_ double dist2goal(Objpos &pos);

_world_utils_extern_ double stamina_usage(int priority);
_world_utils_extern_ double stamina_usage(int priority, double stamina);

#endif
